package com.zipcodewilmington.singlylinkedlist;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedListTest {

    @Test
    public void SinglyLinkedListTest() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("Whatup");
        linkedList.add(" doggs");


        String test = "";

        for (int i = 0; i <= linkedList.size(); i++) {
            String string = (String) linkedList.remove();
            test = test.concat(string);
        }

        System.out.println(test);
    }

    @Test
    public void SinglyLinkedListTest1() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("Whatup");
        linkedList.add(" doggs, ");

        int expected = 2;
        int actual = linkedList.size();

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest2() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");
        linkedList.add(" d,");
        linkedList.add(" e");

        int expected = 5;
        int actual = linkedList.size();

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest3() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        linkedList.insert("HEY", 2);

        int expected = 4;
        int actual = linkedList.size();

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest4() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        linkedList.insert("HEY", 2);


        String expected = "HEY";
        String actual = (String) linkedList.get(3);

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest5() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        String actual = (String) linkedList.removeAt(2);
        String expected = " b,";

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest6() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        String actual = (String) linkedList.remove();
        String expected = "a";

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest7() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        int actual = linkedList.find(" b,");
        int expected = 2;

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest8() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("nerf");
        linkedList.add("sian");
        linkedList.add("foo");

        int actual = linkedList.find("butts");
        int expected = -1;

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest9() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        boolean actual = linkedList.contains("a");
        boolean expected = true;

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest10() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add(" b,");
        linkedList.add(" c,");

        boolean actual = linkedList.contains("z");
        boolean expected = false;

        Assert.assertEquals(actual, expected);
    }

    @Test
    public void SinglyLinkedListTest11() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add("a");
        linkedList.add("b");
        linkedList.add("c");

        SinglyLinkedList actual = linkedList;
        SinglyLinkedList expected = linkedList.copy();

        for (int i = 1; i <= expected.size(); i++) {
            System.out.println(expected.get(i));
        }

        expected.remove();

        for (int i = 1; i <= expected.size(); i++) {
            System.out.println(expected.get(i));
        }

        for (int i = 1; i < linkedList.size()+1; i++) {
            System.out.println(linkedList.get(i));
        }

    }

    @Test
    public void SinglyLinkedListTest12() {
        SinglyLinkedList linkedList = new SinglyLinkedList();

        linkedList.add(20);
        linkedList.add(1);
        linkedList.add(3);
        linkedList.add(15);
        linkedList.add(99);
        linkedList.add(13);
        linkedList.sort();

        for (int i = 1; i < linkedList.size()+1; i++) {
            System.out.println(linkedList.get(i));
        }

        int actual = linkedList.find(20);
        int expected = 5;

        Assert.assertEquals(actual, expected);
    }
}
